using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TS_eSignal
{
    public partial class Form1 : Form
    {
        private IESignal.Hooks esignal;
        int tsHandle;

        public Form1()
        {
            InitializeComponent();
            esignal = new IESignal.Hooks();
            tsHandle = -1;
            esignal.OnTimeSalesChanged += new IESignal._IHooksEvents_OnTimeSalesChangedEventHandler(esignal_OnTimeSalesChanged);
        }

        private void ConnectButton_Click(object sender, EventArgs e)
        {
            esignal.SetApplication(UsernameTextBox.Text);
            //Making the assumption that IsEntitled would return true
            StatusLabel.Text = "SetApplication Called";
            UsernameTextBox.Enabled = false;
            ConnectButton.Enabled = false;
            SymbolTextBox.Enabled = true;
            GetTimeSalesButton.Enabled = true;
        }

        private void GetTimeSalesButton_Click(object sender, EventArgs e)
        {
            if (esignal.IsEntitled != 1)
            {
                MessageBox.Show("IsEntitled returned false. Can't send request.");
                StatusLabel.Text = "Not Entitled";
                return;
            }
            if (SymbolTextBox.Text.Length > 0)
            {
                IESignal.TimeSalesFilter filter;
                if (tsHandle != -1)
                {
                    esignal.ReleaseTimeSales(tsHandle);
                }
                filter = new IESignal.TimeSalesFilter();
                filter.bFilterPrice = 0;
                filter.bFilterQuoteExchanges = 0;
                filter.bFilterTradeExchanges = 0;
                filter.bFilterVolume = 0;
                filter.bQuotes = 1;
                filter.bTrades = 1;
                filter.lNumDays = 1;
                filter.sSymbol = SymbolTextBox.Text;
                tsHandle = esignal.get_RequestTimeSales(ref filter);

                if (esignal.get_IsTimeSalesReady(tsHandle) == 1)
                {
                    //Data already in cache, won't receive event until next "live" tick
                    StatusLabel.Text = "History Complete";
                }
                else
                {
                    StatusLabel.Text = "Request Sent";
                }
            }
        }

        private void esignal_OnTimeSalesChanged(int lHandle)
        {
            if (lHandle == tsHandle)
            {
                if (esignal.get_IsTimeSalesReady(lHandle) == 1)
                {
                    StatusLabel.Text = "History Complete";
                }
                else
                {
                    StatusLabel.Text = "Receiving Data";
                }
                IESignal.TimeSalesData tick;
                tick = esignal.get_GetTimeSalesBar(lHandle, 0);
                LastTickTextBox.Text = (tick.dtTime.Year).ToString() + "-" + (tick.dtTime.Month).ToString() + "-" + (tick.dtTime.Day).ToString() + " " + (tick.dtTime.Hour).ToString() + ":" + (tick.dtTime.Minute).ToString() + ":" + (tick.dtTime.Second).ToString() + " Price:" + (tick.dPrice).ToString() + " Size:" + (tick.lSize).ToString();
                tick = esignal.get_GetTimeSalesBar(lHandle, -(esignal.get_GetNumTimeSalesBars(lHandle) - 1));
                FirstTickTextBox.Text = (tick.dtTime.Year).ToString() + "-" + (tick.dtTime.Month).ToString() + "-" + (tick.dtTime.Day).ToString() + " " + (tick.dtTime.Hour).ToString() + ":" + (tick.dtTime.Minute).ToString() + ":" + (tick.dtTime.Second).ToString() + " Price:" + (tick.dPrice).ToString() + " Size:" + (tick.lSize).ToString();
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (tsHandle != -1)
            {
                esignal.ReleaseTimeSales(tsHandle);
            }
        }

    }
}